"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var ValidationFn = require("fp-ts/lib/Validation");
var Decoder_1 = require("./Decoder");
var AndThen = /** @class */ (function (_super) {
    __extends(AndThen, _super);
    function AndThen(decoderFn, decoder) {
        var _this = _super.call(this) || this;
        _this.decoder = decoder;
        _this.decoderFn = decoderFn;
        return _this;
    }
    AndThen.prototype.run = function (value) {
        var _this = this;
        return this.decoder.run(value).fold(function (errors) { return ValidationFn.failure(errors); }, function (success) { return _this.decoderFn(success).run(value); });
    };
    return AndThen;
}(Decoder_1.default));
exports.default = AndThen;
