"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var NonEmptyArray_1 = require("fp-ts/lib/NonEmptyArray");
var ValidationFn = require("fp-ts/lib/Validation");
var Decoder_1 = require("./Decoder");
var BooleanD = /** @class */ (function (_super) {
    __extends(BooleanD, _super);
    function BooleanD() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BooleanD.prototype.run = function (value) {
        if (typeof value === 'boolean') {
            return ValidationFn.success(value);
        }
        var message = "Value must be a boolean, found \"" + typeof value + "\" instead";
        return ValidationFn.failure(NonEmptyArray_1.nonEmptyArray.of(message));
    };
    return BooleanD;
}(Decoder_1.default));
exports.default = BooleanD;
