"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Decoder_1 = require("./Decoder");
var Map = /** @class */ (function (_super) {
    __extends(Map, _super);
    function Map(fn, decoder) {
        var _this = _super.call(this) || this;
        _this.decoder = decoder;
        _this.fn = fn;
        return _this;
    }
    Map.prototype.run = function (value) {
        return this.decoder.run(value).map(this.fn);
    };
    return Map;
}(Decoder_1.default));
exports.default = Map;
