"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var NonEmptyArray_1 = require("fp-ts/lib/NonEmptyArray");
var ValidationFn = require("fp-ts/lib/Validation");
var Decoder_1 = require("./Decoder");
var Fail = /** @class */ (function (_super) {
    __extends(Fail, _super);
    function Fail(message) {
        var _this = _super.call(this) || this;
        _this.message = message;
        return _this;
    }
    Fail.prototype.run = function () {
        return ValidationFn.failure(NonEmptyArray_1.nonEmptyArray.of(this.message));
    };
    return Fail;
}(Decoder_1.default));
exports.default = Fail;
