"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var ValidationFn = require("fp-ts/lib/Validation");
var Decoder_1 = require("./Decoder");
var Map3 = /** @class */ (function (_super) {
    __extends(Map3, _super);
    function Map3(fn, decoderA, decoderB, decoderC) {
        var _this = _super.call(this) || this;
        _this.decoderA = decoderA;
        _this.decoderB = decoderB;
        _this.decoderC = decoderC;
        _this.fn = fn;
        return _this;
    }
    Map3.prototype.run = function (value) {
        var decoderA = this.decoderA;
        var decoderB = this.decoderB;
        var decoderC = this.decoderC;
        var fn = this.fn;
        return decoderA.run(value).fold(function (errorsA) { return ValidationFn.failure(errorsA); }, function (successA) { return decoderB.run(value).fold(function (errorsB) { return ValidationFn.failure(errorsB); }, function (successB) { return decoderC.run(value).fold(function (errorsC) { return ValidationFn.failure(errorsC); }, function (successC) { return ValidationFn.success(fn(successA, successB, successC)); }); }); });
    };
    return Map3;
}(Decoder_1.default));
exports.default = Map3;
