"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OptionFn = require("fp-ts/lib/Option");
var ValidationFn = require("fp-ts/lib/Validation");
var Decoder_1 = require("./Decoder");
var NullableD = /** @class */ (function (_super) {
    __extends(NullableD, _super);
    function NullableD(decoder) {
        var _this = _super.call(this) || this;
        _this.decoder = decoder;
        return _this;
    }
    NullableD.prototype.run = function (maybeValue) {
        if (maybeValue === null) {
            return ValidationFn.success(OptionFn.none);
        }
        return this.decoder.run(maybeValue).map(OptionFn.some);
    };
    return NullableD;
}(Decoder_1.default));
exports.default = NullableD;
