"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Decoder_1 = require("./Decoder");
var OneOf = /** @class */ (function (_super) {
    __extends(OneOf, _super);
    function OneOf(decoders) {
        var _this = _super.call(this) || this;
        _this.decoders = decoders;
        return _this;
    }
    OneOf.prototype.run = function (value) {
        var firstResult = this.decoders.head.run(value);
        if (firstResult.isSuccess()) {
            return firstResult;
        }
        return this.decoders.tail.reduce(function (decoded, decoder) {
            if (decoded.isSuccess()) {
                return decoded;
            }
            return decoder.run(value);
        }, firstResult);
    };
    return OneOf;
}(Decoder_1.default));
exports.default = OneOf;
